/* OskarView */

#import <Cocoa/Cocoa.h>

@interface OskarView : NSView
{
    IBOutlet id digitalColor;
    IBOutlet id exColor;
    IBOutlet id eyColor;
    IBOutlet id speedSlider;
    IBOutlet id textFeld;
    IBOutlet id triggerButton;
    IBOutlet id triggerSlider;
    
    NSTimer *recordTimer;				// system fired Timer
    NSTimeInterval timeNeeded;	// measure of system timing inaccuracy
    NSBezierPath *exPath;				// contains x-y drawing of EX
    NSBezierPath *eyPath;				// contains x-y drawing of EY
    NSBezierPath *digitalPath;	// contains x-y drawing of digital input

    struct {										// status of control buttons, switches, sliders
      bool displayEX;
      bool displayEY;
      bool displayDigital;
      bool recordStop;
      bool displaySlowSpeed;
      int  triggerChannel;
      int  triggerLevel;
      int  displaySpeed;
      int  xAchse;							// actual x Value
    } oskarParams;
}
- (IBAction)speedSliderChanged:(id)sender;
- (IBAction)startStopButtonChanged:(id)sender;
- (IBAction)triggerButtonChanged:(id)sender;
- (IBAction)triggerSliderChanged:(id)sender;
- (void) startTimer;
- (void) stopTimer;
- (void) prepareRecordData;
- (void) recordData:(id)sender;
@end
