#import "DataContainer.h"

@implementation DataContainer

- (IBAction)addData:(NSString *)value from:(unsigned char)source 
{
  int remaining;
  int spaceInString;
  int offset;
  unsigned int start;
  unsigned int len;
  NSRange theRange;

  
  NSMutableString *valueNoCR =[NSMutableString stringWithString:value];// remove CR from ASCII string
  len = [valueNoCR length];
  for (start = 0; start < len; start++){
	if (([valueNoCR characterAtIndex:start] < 0x20) || ([valueNoCR characterAtIndex:start] > 0x7E)){
		theRange.location = start;
		theRange.length = 1;
		[valueNoCR replaceCharactersInRange:theRange withString:@"*"];
	
	}
  }

  spaceInString = 16 - [dataASCIIString length];
  remaining = [value length];
  if (spaceInString >= remaining){	//value to add fits into dataSentString
    [dataASCIIString appendAttributedString:[[NSAttributedString alloc]initWithString:valueNoCR attributes:fontParameter[source]]];
      [dataHEXString appendAttributedString:[self convertToHex:value from:source]];
  }
  else{
    offset = 0;
    while (remaining){									// value to add does not fit into dataSentString, so fragment it
      spaceInString = 16 - [dataASCIIString length];      
      if (spaceInString == 0){			// put old dataSentString in Array, then clear dataSentString
        [dataArray addObject:[dataASCIIString copy]];
        [dataArray addObject:[dataHEXString copy]];
        start = 0;
        len = [dataASCIIString length];
        [dataASCIIString replaceCharactersInRange:NSMakeRange(start,len) withString:@""];
        len = [dataHEXString length];
        [dataHEXString replaceCharactersInRange:NSMakeRange(start,len) withString:@""];
        spaceInString = 16;      
      }
      // here dataSentString has 1 - 16 bytes free
      if (spaceInString >= remaining){
        [dataASCIIString appendAttributedString: [[NSAttributedString alloc]initWithString:[valueNoCR substringWithRange:NSMakeRange(offset, remaining)] attributes:fontParameter[source]]];
        [dataHEXString appendAttributedString:[self convertToHex:[value substringWithRange:NSMakeRange(offset, remaining)] from:source]];
        remaining = 0;
      }
      else{
        [dataASCIIString appendAttributedString:[[NSAttributedString alloc]initWithString:[valueNoCR substringWithRange:NSMakeRange(offset, spaceInString)] attributes:fontParameter[source]]];
        [dataHEXString appendAttributedString:[self convertToHex:[value substringWithRange:NSMakeRange(offset, spaceInString)] from:source]];
        offset += spaceInString;
        remaining -= spaceInString;
      }
    }
  }
  [dataDisplay reloadData];
  [dataDisplay scrollRowToVisible:(([dataArray count]/2))];
  //[valueNoCR autorelease];
}


- (int) numberOfRowsInTableView:(NSTableView *)tableView{
  if (([dataArray count] == 0) && ([dataASCIIString length] == 0))
    return 0;// nothing inside
  if (([dataArray count] == 0) && ([dataASCIIString length] > 0))
    return 1;//only dataSentString inside
  else
    return (([dataArray count]/2)+1);//dataSentArray and dataSentString inside
  return 0; // to prevent compiler warning, instruction never executet
}

- (id) 	tableView:(NSTableView *)tableView
        objectValueForTableColumn:(NSTableColumn *)tableColumn
        row:(int) row{
  NSMutableAttributedString *returnValue; 
  switch ([[tableColumn identifier]intValue]){
    case 0://hex data
      if (row >= ([dataArray count]/2))
      	returnValue = dataHEXString;
      else
        returnValue = [dataArray objectAtIndex:(row*2+1)];
      break;
    case 1://ascii data
    	if (row >= ([dataArray count]/2))
      	returnValue = dataASCIIString;
      else
        returnValue = [dataArray objectAtIndex:(row*2)];
      break;
  }
  return returnValue;  
}

-(id)init{
  int i;
  self = [super init];
  for (i = 0;i <= 1; i++){
    fontParameter[i] = [[NSMutableDictionary dictionaryWithCapacity:4] retain];
    fontParameter[i] = [[NSMutableDictionary dictionaryWithCapacity:4] retain];
    [fontParameter[i] setObject:[NSFont fontWithName:@"Monaco" size:12.0] forKey:NSFontAttributeName];
  }
  [fontParameter[0] setObject:[NSColor greenColor] forKey:NSBackgroundColorAttributeName];
  [fontParameter[1] setObject:[NSColor yellowColor] forKey:NSBackgroundColorAttributeName];
  
  dataASCIIString = [[NSMutableAttributedString alloc]initWithString:@"" attributes:fontParameter[0]];
  dataHEXString = [[NSMutableAttributedString alloc]initWithString:@"" attributes:fontParameter[1]];
  dataArray = [[NSMutableArray arrayWithCapacity:32] retain];
  
  return self;
}

-(void) dealloc{
  [dataASCIIString release];
  [dataHEXString release];
  [dataArray release];
  [fontParameter[0] release];
  [fontParameter[1] release];
  [super dealloc];
}
//
// Convert a string with ASCII-Characters to an String containing same characters as Hex display
// Example: "ABC" is converted to "41 42 43"
//
-(NSAttributedString *)convertToHex:(NSString *)value from:(unsigned char)source{
  NSAttributedString *hexAttributedString;
  NSString *hexString;
  int i,j;
  unsigned char helper;
  unichar oneCharacter;
  unsigned char CString[48];
  
  j = 0;
  for (i = 0; i < [value length];i++){
    oneCharacter = [value characterAtIndex:i];
    helper = oneCharacter/16;													//create first Digit
    if (helper > 15)
      helper = 15;
    if (helper > 9)
      CString[j++] = helper +55;
    else
      CString[j++] = helper +48;
      
    helper =	oneCharacter - ((oneCharacter/16)*16);	//create last Digit
    if (helper > 15)
      helper = 15;
    if (helper > 9)
      CString[j++] = helper +55;
    else
      CString[j++] = helper +48;
      
    CString[j++] = 0x20; 															// blank as separator
  }
  CString[j] = 0;
  hexString = [[NSString alloc] initWithCString:CString];
      
  hexAttributedString = [[NSAttributedString alloc] initWithString:hexString attributes:fontParameter[source]];
  [hexAttributedString retain];
  return hexAttributedString;
}
@end
